Unit IIS4R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTII10_p;

procedure IIS4R(var X :Array of Real; var Y :Array of Real;
                NX :Integer; var C :Array of Real;
                var U :Array of Real; var S :Array of Real;
                M :Integer; var IERR :Integer);

implementation

procedure IIS4R(var X :Array of Real; var Y :Array of Real;
                NX :Integer; var C :Array of Real;
                var U :Array of Real; var S :Array of Real;
                M :Integer; var IERR :Integer);
var
JER,KER,K,J,IER1,NXM1 :Integer;
D,DD :Real;
const
I :Integer = 1;
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14;
begin
if ( M <= 0 ) 
 then goto _14;
IER1 := IERR;
IERR := 0;
JER := 0;
KER := 0;
NXM1 := NX-1;
if ( IER1 = 111111 ) 
 then goto _2;
if ( NX < 2 ) 
 then goto _11;
for J:=1 to NXM1 do
 begin
  D := X[J+0]-X[J-1];
  if ( D <= ZERO ) 
   then goto _12;
_1:
 end;
_2:
if ( I > NXM1 ) 
 then I := 1;
for K:=1 to M do
 begin
  D := U[K-1]-X[I-1];
  if ( D ) < 0
   then goto _3
   else if ( D ) > 0
         then goto _5
         else goto _7;
_3:
  if ( I = 1 ) 
   then goto _8;
  I := I-1;
  D := U[K-1]-X[I-1];
  if ( D ) < 0
   then goto _3
   else if ( D ) > 0
         then goto _6
         else goto _7;
_4:
  I := I+1;
  D := DD;
_5:
  if ( I >= NX ) 
   then goto _9;
  DD := U[K-1]-X[I+0];
  if ( DD >= ZERO ) 
   then goto _4;
  if ( D = ZERO ) 
   then goto _7;
_6:
  S[K-1] := ((C[2+(I-1)*3]*D+C[1+(I-1)*3])*D+C[0+(I-1)*3])*D+Y[I-1];
  goto _10;
_7:
  S[K-1] := Y[I-1];
  goto _10;
_8:
  JER := 1;
  goto _6;
_9:
  if ( DD > ZERO ) 
   then KER := 2;
  D := U[K-1]-X[NXM1-1];
  I := NXM1;
  goto _6;
_10:
 end;
IERR := Max0(JER,KER);
if ( IER1 = 111111 ) 
 then goto _14;
IERR := JER;
if ( IERR <> 0 ) 
 then UTII10(IERR,4);
IERR := KER;
if ( IERR <> 0 ) 
 then UTII10(IERR,4);
goto _14;
_11:
IERR := 65;
goto _13;
_12:
IERR := 66;
_13:
if ( IER1 = 111111 ) 
 then goto _14;
UTII10(IERR,4);
_14:
end;

end.
